function EDTtoggleProjectPane(){
 var Button = $('#project_pane_toggle');
 if (Button.hasClass('on')){
  $('#EDTprojectManager').hide();
  $("div.CodeMirror-wrapping").css('left', '0px');
  Button.removeClass('on');
  COOKIEcreate('EDTshowProjectPane', 'false', 365);
 } else {
  var ProjectPane = $('#EDTprojectManager');
  ProjectPane.show();
  $("div.CodeMirror-wrapping").css('left', ProjectPane.outerWidth() + 'px');
  Button.addClass('on');
  COOKIEcreate('EDTshowProjectPane', 'true', 365);
 } 
}

function EDTtoggleThumbnail(Editor){
 if($("div#EDTthumbnailScroll").is(":visible")){
  $("div#EDTthumbnailScroll").hide();
  $("div.CodeMirror-wrapping").css("right", "0px");
  $("#thumbnail_toggle").removeClass("on");
  COOKIEcreate("thumbnail_show", "false", 365);
 }
 else{
  $("div#EDTthumbnailScroll").show();
  $("div.CodeMirror-wrapping").css("right", $("div#EDTthumbnailScroll").css("width"));
  $("#thumbnail_toggle").addClass("on");
  ETHscrollerControl.resize(Editor);
  COOKIEcreate("thumbnail_show", "true", 365);
 } 
}

function EDTretrieveThumbnailAbsoluteTopMargin(){
 if("Safari" == BrowserDetect.browser){
  return 78;
 }

 var EditorTopOffset = parseInt($(".content_main").css("top").match(/\d(\d+)?/g)[0]);
 var EditorTitleHeight = parseInt($(".EDTtoolbar_wrapper").css("height").match(/\d(\d+)?/g)[0]);

 return EditorTopOffset + EditorTitleHeight + 10;
}

function EDTscrollEditor(e, Editor){
 var EditorLineHeight =  NIScharHeight(Editor);

 var ThumbnailScrollBarHeight = Math.floor($("div.CodeMirror-wrapping").get(0).clientHeight / EditorLineHeight);
 var ThumbnailScrollBarVerticalPosition = Math.max(0, (e.pageY - EDTretrieveThumbnailAbsoluteTopMargin()) - Math.floor(ThumbnailScrollBarHeight /2));

 if(ThumbnailScrollBarVerticalPosition <= parseInt($("svg").attr("height"))){
  var ScrollTop = (ThumbnailScrollBarVerticalPosition * EditorLineHeight) / ETHscrollerControl.retrieveVerticalScale();
  $(".CodeMirror-iframe").get(0).contentWindow.scrollTo($(".CodeMirror-iframe").get(0).contentWindow.scrollX,ScrollTop);
 }
}

function EDTsetupHeader(Editor, Params){
 var ToolDiv = NIScreateToolbar(Editor, Params);
 $('div.EDTtoolbar_wrapper').append(ToolDiv);
 if (COOKIEread('EDTshowProjectPane') == 'false'){
  EDTtoggleProjectPane();
 }
 NIScreateStatusBar(Editor, $('div.EDTstatus_bar'));
}

function EDTopenEditor(Params){
 var H = MAPretrieveHeaderHTML("lua_editor", Params);
 H += '<div class="content_main floated_bottom">\
        <div class="EDTtoolbar_wrapper" />\
        <div id="EDTeditor">\
         <div id="EDTprojectManager" />\
         <div id="EDTthumbnailScroll" />\
        </div>\
        <div class="EDTstatus_bar" />\
       </div>';

 $(document).find("body").html(H);
  
 NIScreateEditor(document.getElementById('EDTeditor'), EDTsetupHeader, Params);
}

function EDTappendIframeDialogFixDiv(){
 if (!$('.EDTiframeDialogFix').size()){
  $('<div class="EDTiframeDialogFix />').appendTo('body');
 }
}

function EDTremoveIframeDialogFixDiv(){
 $('.EDTiframeDialogFix').remove();
}

function EDTiframeDialogFix(Dialog, OnDragStop, OnResizeStop){
 Dialog.dialog('option', 'dragStart',   EDTappendIframeDialogFixDiv);
 Dialog.dialog('option', 'dragStop',    EDTremoveIframeDialogFixDiv);
 Dialog.dialog('option', 'resizeStart', EDTappendIframeDialogFixDiv);
 Dialog.dialog('option', 'resizeStop',  EDTremoveIframeDialogFixDiv);
}
