// The initial show function.  Note that we do not draw immeditately to the control since it must be loaded 
// before we can work with it.
function ETHshow(Container, BlockDataSet){
 ETHclear(Container);

 Container.html("<canvas id='ETHcontrol' width='100px' height='" + Container.height() + "px'></canvas>");

 var ctx = document.getElementById("ETHcontrol").getContext("2d");  

 for(var i = 0; i < BlockDataSet.length; ++i){
  var BlockData = BlockDataSet[i];
  if(BlockData.type == "annotation"){
   ctx.fillStyle = "red";
  }
  else if(BlockData.type == "line"){
   ctx.fillStyle = "black";
  }
  else{
   ctx.fillStyle = "red";
  }
  ctx.fillRect(BlockData.c + 2, BlockData.s, Container.width() - BlockData.c - 4, BlockData.e - BlockData.s); 
 }
}

function ETHclear(Container){
 Container.html("");
}

function ETHonResize(Container){
}
