var SPDEnewLine = "";

function SPDEedit(Params){
 var ChannelInfo = {Guid: PAGgetField(Params,'ChannelGuid'), Name: PAGgetOptionalField(Params,'ChannelName')};
 var ComponentInfo = {Type: PAGgetOptionalField(Params,'ComponentType'), Name: PAGgetOptionalField(Params,'ComponentName')};

 var H = MAPretrieveHeaderHTML("message_edit", Params);
 H += '<div class="content_main floated_bottom"></div>'
 
 $(document).find("body").html(H);
 var ChannelGuid = ChannelInfo.Guid;
 var MessageId = PAGgetField(Params,'Id');
 
 // Now that the header and main div are in place, make our own absolutely positioned main div.
 H = '<div class="SPDwarning"></div><div class="EDTtoolbar_wrapper"><span id="sample_data_control"></span>';
 H += 'EDIT MESSAGE' 
 H += '<div class="section" style="float:right;padding-left:0px;"><span class="label">';
 H += PAGlink("SampleData", MAPretrieveParams("message_preview", Params), "Sample Data");
 H += '</span></div>' 
 H += '<div class="section" style="float:right;padding-right:0px;"><span class="label">';
 H += '<img style="vertical-align:middle;" src="/js/mapper/images/toolbar/arrow.png" /> Back to:&nbsp;&nbsp;';
 H += PAGlink("OpenEditor", MAPretrieveParams("lua_editor", Params), "Script");
 H += '</span></div>';
 H += '</div>';
 H += '<div class="SPDeditorWrapper"><textarea id="SPDmessageEditor" class="SPDeditor" style="width:100%;height:92%;"></textarea><hr>'
    + BTNwrapper(BTNbuttonMinusWithJavascript("javascript:SPDEcancel();", "Cancel")
    +            BTNbuttonPlusWithJavascript("javascript:SPDEsaveMessage(\"" + ChannelGuid + "\", " + MessageId + ");", "Save"))
    + '<a id="SPDdefaultBackLink" href="' + PAGhref('SampleData', MAPretrieveParams("message_preview", Params)) + '" style="display:none;"></a>'
    + '</div><div class="SPDajaxError"></div>';
 
 $("div.content_main").css('top',  $("div.header").height() + 'px');
 $("div.content_main").html(H);
  
 Params.MPRapp = MPRapp.type;
 Ajax.post('/sample_data', Params, function(Response, TextStatus, RequestObject){ SPDErenderEditSampleData(Response); }, 'json');
}

function SPDErenderEditSampleData(Response){
 if (Response.ErrorMessage){
  MPRapp.renderError(Response.ErrorMessage); 
  return;
 }
 
 // Now that the header and main div are in place, make our own absolutely positioned main div.
 var WarningRendered = false;
 if (Response.BadAsciiChars){
  var Warning = '<div><span style="font-weight:bold;">WARNING:</span> this message contains invalid characters that cannot be represented in an editor. ';
  Warning += 'Invalid characters are displayed as \'?\'. Saving this message will result in loss of data.</div></div>';
  $("div.SPDwarning").html(Warning);
  WarningRendered = true;
 }

 var SampleData = Response.Data;
 if(-1 != SampleData.search(/\n\r/)){
  SPDEnewLine = "\r\n"; 
 }
 else if(-1 != SampleData.search(/\r/)){
  SPDEnewLine = "\r"; 
 }
 else{
  SPDEnewLine = "\n";
 }

 $("textarea#SPDmessageEditor").html(SampleData);
 
 if (WarningRendered){
  $('div.SPDeditorWrapper').css('top', '100px');
 }
}

function SPDEsaveMessage(ChannelGuid, SampleDataId){
 var ModifiedData = $('#SPDmessageEditor').val();
 if((-1 != ModifiedData.search(/\r\n/)) && ("\r\n" != SPDEnewLine)){
  ModifiedData = ModifiedData.replace(/\r\n/g, SPDEnewLine);
 }
 else if((-1 != ModifiedData.search(/\r/)) && ("\r" != SPDEnewLine)){
  ModifiedData = ModifiedData.replace(/\r/g, SPDEnewLine); 
 }
 else if((-1 != ModifiedData.search(/\n/)) && ("\n" != SPDEnewLine)){
  ModifiedData = ModifiedData.replace(/\n/g, SPDEnewLine); 
 }

 Ajax.post('/update_sample_data', {'ChannelGuid':ChannelGuid, 'Id':SampleDataId, 'Message':ModifiedData}, SPDEhandleSaveResult, 'json');
}

function SPDEhandleSaveResult(Response, TextStatus, RequestObject){
 if (Response.ErrorMessage){
  $("div.SPDeditorWrapper").css("bottom", "50px");
  $("div.SPDajaxError").html(Response.ErrorMessage); 
  return;
 }
 else{
   SPDEcancel();
 }
}

function SPDEcancel(){
 if (history.length > 1){
  history.back();
 } else {
  location.href=$("#SPDdefaultBackLink").attr("href");
 }
}
