<?cs include:"doctype.cs" ?>
<script type="text/javascript" src="<?cs var:iguana_version_js("/js/ajax/ajax.js") ?>"></script>

<html>  <?cs # vim: set syntax=html :?>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings</title>
   <?cs include:"styles.cs" ?>
   
   <SCRIPT LANGUAGE="JavaScript">
		<!-- Begin

		image1 = new Image();
		image1.src = "../<?cs var:skin("images/web_server_config_hover.gif") ?>";
		image1.src = "../<?cs var:skin("images/web_server_config_active.gif") ?>";

		image2 = new Image();
		image2.src = "../<?cs var:skin("images/database_settings_hover.gif") ?>";
		image2.src = "../<?cs var:skin("images/database_settings_active.gif") ?>";
		
		image3 = new Image();
		image3.src = "../<?cs var:skin("images/email_notification_hover.gif") ?>";
		image3.src = "../<?cs var:skin("images/email_notification_active.gif") ?>";
		
		image4 = new Image();
		image4.src = "../<?cs var:skin("images/logging_hover.gif") ?>";
		image4.src = "../<?cs var:skin("images/logging_active.gif") ?>";
		
		image5 = new Image();
		image5.src = "../<?cs var:skin("images/plugin_settings_hover.gif") ?>";
		image5.src = "../<?cs var:skin("images/plugin_settings_active.gif") ?>";
		
		image6 = new Image();
		image6.src = "../<?cs var:skin("images/change_password_hover.gif") ?>";
		image6.src = "../<?cs var:skin("images/change_password_active.gif") ?>";
		
		image7 = new Image();
		image7.src = "../<?cs var:skin("images/users_and_groups_hover.gif") ?>";
		image7.src = "../<?cs var:skin("images/users_and_groups_active.gif") ?>";
		
		image8 = new Image();
		image8.src = "../<?cs var:skin("images/license_entitlement_hover.gif") ?>";
		image8.src = "../<?cs var:skin("images/license_entitlement_active.gif") ?>";
		
		image9 = new Image();
		image9.src = "../<?cs var:skin("images/environment_variables_hover.gif") ?>";
		image9.src = "../<?cs var:skin("images/environment_variables_active.gif") ?>";
		
		image10 = new Image();
		image10.src = "../<?cs var:skin("images/channel_groups_hover.gif") ?>";
		image10.src = "../<?cs var:skin("images/channel_groups_active.gif") ?>";

		image11 = new Image();
		image11.src = "../<?cs var:skin("images/remote_iguana_hover.gif") ?>";
		image11.src = "../<?cs var:skin("images/remote_iguana_active.gif") ?>";

//		image12 = new Image();
//		image12.src = "../<?cs var:skin("images/source_repository_hover.gif") ?>";
//		image12.src = "../<?cs var:skin("images/source_repository_active.gif") ?>";

		// End -->
	</script>
   
</head>

<body class="tabright">

<?cs set:Navigation.CurrentTab = "Settings" ?>

<?cs include:"header.cs" ?>

<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            Settings
         </td>
      </tr>

      <tr>
         <td id="dashboard_body">
            <center>
			<div id="button_container"> <!-- This restricts the max width of the table -->

				<table class="configuration">
					<tr>
						<th>Iguana Program Settings</th>
					</tr>
					<tr>
						<td>
						<center>
<!-- Keep a/img tags on the same line in order to prevent FF2 white space issues -->
<a class="settings_button" href="/web_settings_view.html" 
onmousedown="image1.src='../<?cs var:skin("images/web_server_config_active.gif") ?>';"
onmouseover="image1.src='../<?cs var:skin("images/web_server_config_hover.gif") ?>';"
onmouseout="image1.src='../<?cs var:skin("images/web_server_config.gif") ?>';"><img name="image1" width=150 height=60 src="../<?cs var:skin("images/web_server_config.gif") ?>" border=0></a>

<a class="settings_button" href="/databases.html" 
onmousedown="image2.src='../<?cs var:skin("images/database_settings_active.gif") ?>';"
onmouseover="image2.src='../<?cs var:skin("images/database_settings_hover.gif") ?>';"
onmouseout="image2.src='../<?cs var:skin("images/database_settings.gif") ?>';"><img name="image2" width=150 height=60 src="../<?cs var:skin("images/database_settings.gif") ?>" border=0></a>

<a class="settings_button" href="/email_status.html" 
onmousedown="image3.src='../<?cs var:skin("images/email_notification_active.gif") ?>';"
onmouseover="image3.src='../<?cs var:skin("images/email_notification_hover.gif") ?>';"
onmouseout="image3.src='../<?cs var:skin("images/email_notification.gif") ?>';"><img name="image3" width=150 height=60 src="../<?cs var:skin("images/email_notification.gif") ?>" border=0></a>

<a class="settings_button" href="/log_settings_view.html" 
onmousedown="image4.src='../<?cs var:skin("images/logging_active.gif") ?>';"
onmouseover="image4.src='../<?cs var:skin("images/logging_hover.gif") ?>';"
onmouseout="image4.src='../<?cs var:skin("images/logging.gif") ?>';"><img name="image4" width=150 height=60 src="../<?cs var:skin("images/logging.gif") ?>" border=0></a>

<a class="settings_button" href="/rpc_settings_view.html" 
onmousedown="image5.src='../<?cs var:skin("images/plugin_settings_active.gif") ?>';"
onmouseover="image5.src='../<?cs var:skin("images/plugin_settings_hover.gif") ?>';"
onmouseout="image5.src='../<?cs var:skin("images/plugin_settings.gif") ?>';"><img name="image5" width=150 height=60 src="../<?cs var:skin("images/plugin_settings.gif") ?>" border=0></a>

<a class="settings_button" href="/editUser?user=<?cs var:url_escape(CurrentUser) ?>&change_password=true" 
onmousedown="image6.src='../<?cs var:skin("images/change_password_active.gif") ?>';"
onmouseover="image6.src='../<?cs var:skin("images/change_password_hover.gif") ?>';"
onmouseout="image6.src='../<?cs var:skin("images/change_password.gif") ?>';"><img name="image6" width=150 height=60 src="../<?cs var:skin("images/change_password.gif") ?>" border=0></a>

<a class="settings_button" href="/role_control.html" 
onmousedown="image7.src='../<?cs var:skin("images/users_and_groups_active.gif") ?>';"
onmouseover="image7.src='../<?cs var:skin("images/users_and_groups_hover.gif") ?>';"
onmouseout="image7.src='../<?cs var:skin("images/users_and_groups.gif") ?>';"><img name="image7" width=150 height=60 src="../<?cs var:skin("images/users_and_groups.gif") ?>" border=0></a>

<a class="settings_button" href="/license_settings.html" 
onmousedown="image8.src='../<?cs var:skin("images/license_entitlement_active.gif") ?>';"
onmouseover="image8.src='../<?cs var:skin("images/license_entitlement_hover.gif") ?>';"
onmouseout="image8.src='../<?cs var:skin("images/license_entitlement.gif") ?>';"><img name="image8" width=150 height=60 src="../<?cs var:skin("images/license_entitlement.gif") ?>" border=0></a>

<a class="settings_button" href="/https_channel_settings.html" 
onmousedown="image11.src='../<?cs var:skin("images/https_channels_active.gif") ?>';"
onmouseover="image11.src='../<?cs var:skin("images/https_channels_hover.gif") ?>';"
onmouseout="image11.src='../<?cs var:skin("images/https_channels.gif") ?>';"><img name="image11" width=150 height=60 src="../<?cs var:skin("images/https_channels.gif") ?>" border=0></a>

<a class="settings_button" href="/update_environment" 
onmousedown="image9.src='../<?cs var:skin("images/environment_variables_active.gif") ?>';"
onmouseover="image9.src='../<?cs var:skin("images/environment_variables_hover.gif") ?>';"
onmouseout="image9.src='../<?cs var:skin("images/environment_variables.gif") ?>';"><img name="image9" width=150 height=60 src="../<?cs var:skin("images/environment_variables.gif") ?>" border=0></a>
		
<a class="settings_button" href="/channel_groupings_control.html" 
onmousedown="image10.src='../<?cs var:skin("images/channel_groups_active.gif") ?>';"
onmouseover="image10.src='../<?cs var:skin("images/channel_groups_hover.gif") ?>';"
onmouseout="image10.src='../<?cs var:skin("images/channel_groups.gif") ?>';"><img name="image10" width=150 height=60 src="../<?cs var:skin("images/channel_groups.gif") ?>" border=0></a>

<a class="settings_button" href="/remote_iguana_settings_view.html" 
onmousedown=" image11.src='../<?cs var:skin("images/remote_iguana_active.gif") ?>';"
onmouseover=" image11.src='../<?cs var:skin("images/remote_iguana_hover.gif") ?>';"
onmouseout=" image11.src='../<?cs var:skin("images/remote_iguana.gif") ?>';"><img alt="Remote Iguana(s)" name="image11" width=150 height=60 src="../<?cs var:skin("images/remote_iguana.gif") ?>" border=0></a>

<!--
<a class="settings_button" href="/source_repository_settings" 
onmousedown="image12.src='../<?cs var:skin("images/source_repository_active.gif") ?>';"
onmouseover="image12.src='../<?cs var:skin("images/source_repository_hover.gif") ?>';"
onmouseout="image12.src='../<?cs var:skin("images/source_repository.gif") ?>';"><img name="image12" src="../<?cs var:skin("images/source_repository.gif") ?>" border=0></a>
-->
               			</center>
               			</td>
               		</tr>
               	</table>
			</div>

<br>

               	
<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
            <p>
               On this page, you can customize your version of Iguana by changing its settings.
            </p>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana4_settings.html" target="_blank">Changing the Iguana Program Settings</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>
</div>
              	
               	<br><br><br>
           
            </center>
         </td>
      </tr>

   </table>

</div>

</body>

</html>
