<?cs include:"doctype.cs" ?>

<html>
<head>
   <title>Iguana License Required<?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?></title>
   <?cs include:"styles.cs" ?>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
</head>
<body class="tabright">

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>


<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            
         </td>
      </tr>

      <tr>
         <td id="dashboard_body">
            <center>
               <h3><?cs var:html_escape(ErrorMessage) ?></h3>	   

               <!-- Check for OS version -->
               <?cs if:LicenseResult != 6 ?>
               <table class="configuration">
                  <tr><th colspan="2" style="padding:5px;">&nbsp;</th></tr>
                  <tr>
                     <td class="left_column">Iguana ID</td>
                     <td><?cs var:IguanaId ?></td>
                  </tr>
               </table>
               <p>If you already have an 
	       <a href="http://members.interfaceware.com/myInterfaceware">iNTERFACEWARE member account</a>, 
	       go to the registration codes section to retrieve a free Iguana trial license.</p>
               <p>If you do not have a member account, and wish to obtain a trial license, you can <a href="http://members.interfaceware.com/myInterfaceware/createAccountForIguanaRegistration.html?action=Modify&amp;Id=<?cs var:IguanaId ?>">create an account</a>.</p>
            
            <p>Click on the button below to enter your registration code.</p>
               <table> <tr><td>
               <?cs if:CurrentUserCanAdmin ?>
                  <a id="NewLicense" class="button" href="edit_license_settings.html" onclick="this.blur()"><span>Enter License Code</span></a>
               </td></tr></table>
               <?cs else ?>
                  <div class="button_disable" id="DisabledEditButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span>Enter License Code</span></div>
               <?cs /if ?>
               <?cs /if ?>
            </center>
           </td>
	   </tr>
   </table>

</div>
      <div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
            <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
	     <p>
	 This page is displayed if you do not yet have a license for your copy of Iguana, or if this version of Iguana is unsupported by your OS.
	 </p>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana_getting_started.html" target="_blank">Getting Started</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>
   </div>
</body>
</html>
