function SPDview(Params){
 var ChannelInfo = {Guid: PAGgetField(Params,'ChannelGuid'), Name: PAGgetOptionalField(Params,'ChannelName')};
 var ComponentInfo = {Type: PAGgetOptionalField(Params,'ComponentType'), Name: PAGgetOptionalField(Params,'ComponentName')};

 var H = MAPretrieveHeaderHTML("message_preview", Params);
 H += '<div class="content_main">';
 H += '<div class="EDTtoolbar_wrapper"><span id="sample_data_control"></span>';
 H += 'SAMPLE DATA' 
 H += '<div class="section" style="float:right;padding-right:0px;"><span class="label">';
 H += '<img style="vertical-align:middle;" src="/js/mapper/images/toolbar/arrow.png" /> Back to:&nbsp;&nbsp;';
 H += PAGlink("OpenEditor", MAPretrieveParams("lua_editor", Params), "Script");
 H += '</span></div>';
 H += '</div>';
 H += '<div class="SPDnavPane"></div>';
 H += '<div class="SPDdataTable"></div>';
 H+= '<form class="SPDuploadForm"><input type="hidden" name="MPRapp" value="' + MPRapp.type + '" /><input type="hidden" name="ChannelGuid" value="' + ChannelInfo.Guid + '" />';
 H+= '<table class="import_table"><tr><th colspan="2" style="height:30px;">Import Sample Data</th></tr>';
 H+= '<tr><td>Message File:</td><td>';
 H+= '<div id="file_chooser"><input type="file" class="medium" id="import_file" name="ImportFile" /></div></td></tr>';
 H+= '<tr><td></td><td style="padding-top:0px;">';
 H+= '<div id="SPDimportOverwriteContainer"><input type="checkbox" name="SPDimportOverwrite" id="SPDimportOverwrite" style="margin:0px;">&nbsp;Overwrite all existing samples</div>';
 H+= '</td></tr><tr><td colspan="2" style="height:40px;"><span class="BTNbuttons"><a id="SPDimportButton" href="javascript:void(0);" style="cursor:default;opacity:.5;">Import</a></span>';
 H+= '</td></tr></table></form><br><span id="status">';   
 H += '</span></div></div>';
 
 $('body').html(H);

 if (!Params.Chunk && !Params.Index) Params.Chunk = 0;
 Params.MPRapp = MPRapp.type;
 Ajax.post('/sample_preview', Params, function(Response, TextStatus, RequestObject){ SPDrenderSampleDataView(Response, Params); }, 'json');
}

function SPDpreviewRow(Preview, WasImported, Params){
 Params.Id = Preview.index + 1;
 var H = '<tr' + (WasImported ? (' class="SPDimportedRow"') : '') + '><td class="SPDindex">' + (Preview.index+1) +'&nbsp;<td>' + Preview.text +
  '<td class="SPDop">&nbsp;' +
  PAGlink('EditSampleData', Params, '<img class="SPDeditButton" src="/js/mapper/images/edit.png" />');
  
  // Not allowed currently.  See #16266.
  //' <img class="SPDdeleteButton" src="/js/mapper/images/close_button_gray.gif" onclick="javascript:SPDdeleteSampleData(this, ' +
  //Preview.id + ', \'' + ChannelGuid + '\');"/>';
  
  return H;
}

function SPDbutton(Page, Text, Params, Condition){
 if (Condition){
  return PAGlink(Page, Params, Text);
 }
 else{
  return '<a class="SPDdisabled">' + Text + '</a>';
 }
}

function SPDupdateSampleDataView(Response, Params){
 if (!Response){
  MPRapp.renderError("Unable to get sample data from server. Check if it is running.");
  return;
 }
 else if (Response.ErrorMessage){
  MPRapp.renderError(Response.ErrorMessage); 
  return;
 }

 var ChannelInfo = {Guid: PAGgetField(Params,'ChannelGuid'), Name: PAGgetOptionalField(Params,'ChannelName')};
 var ComponentInfo = {Type: PAGgetOptionalField(Params,'ComponentType'), Name: PAGgetOptionalField(Params,'ComponentName')};

 var CurrentChunk = Response.Chunk;
 var LastChunk = Response.CountOfChunk-1;
 var ChunkText = Response.CountOfMessage + ' Messages';
 if (Response.CountOfMessage) ChunkText = (Response.ChunkBegin+1) + ' to ' + (Response.ChunkEnd+1) + ' of ' + ChunkText;
 
 Params.Chunk = 0;
 var NavButton1 = SPDbutton('SampleData', '&lt;&lt;', Params, (CurrentChunk > 0));
 Params.Chunk = Math.max(0, CurrentChunk-1);
 var NavButton2 = SPDbutton('SampleData', '&lt;', Params, (CurrentChunk > 0));
 Params.Chunk = Math.min(LastChunk, CurrentChunk+1);
 var NavButton3 = SPDbutton('SampleData', '&gt;', Params, (CurrentChunk < LastChunk));
 Params.Chunk = LastChunk;
 var NavButton4 = SPDbutton('SampleData', '&gt;&gt;', Params, (CurrentChunk < LastChunk));
 delete Params.Chunk;

 var MessagesNav = BTNwrapper(NavButton1 + NavButton2 + '<span class="SPDnavText">' + ChunkText + '</span>' + NavButton3 + NavButton4);
 $("div.SPDnavPane").html(MessagesNav);

 var TableHtml = '<table id="sample_data_table" class="SPDdataTable">';
 
 var CountOfSample = Response.Previews.length;
 var CountOfImported = Response.Imported;
 for (var SampleIndex = 0; SampleIndex < CountOfSample; SampleIndex++){
  var SdParams = Params;
  SdParams.TotalSd = CountOfSample;
  TableHtml += SPDpreviewRow(Response.Previews[SampleIndex], CountOfImported && (SampleIndex >= CountOfSample - CountOfImported), SdParams);
 }
 TableHtml += '</table>';
 
 $("div.SPDdataTable").html(TableHtml);

 $("div#file_chooser").html('<input type="file" class="medium" id="import_file" name="ImportFile" />');
 $("span#status").html("");
 $("input#SPDimportOverwrite").attr('checked', false);
 
 $('tr.SPDimportedRow').each(function(){
  var Row = $(this);
  Row.removeClass('SPDimportedRow');
  Row.css('background-color', '#C6FF83'); // light green
  setTimeout(function(){
   Row.animate({'background-color':'#FDFDFD'}, 2000); // fade to original bg color
  }, 4000);
 });
}

function SPDrenderSampleDataView(Response, Params){
 if (Response.ErrorMessage){
  MPRapp.renderError(Response.ErrorMessage); 
  return;
 }

 var ChannelInfo = {Guid: PAGgetField(Params,'ChannelGuid'), Name: PAGgetOptionalField(Params,'ChannelName')};
 var ComponentInfo = {Type: PAGgetOptionalField(Params,'ComponentType'), Name: PAGgetOptionalField(Params,'ComponentName')};

 var CurrentChunk = Response.Chunk;
 var LastChunk = Response.CountOfChunk-1;
 var ChunkText = Response.CountOfMessage + ' Messages';
 if (Response.CountOfMessage) ChunkText = (Response.ChunkBegin+1) + ' to ' + (Response.ChunkEnd+1) + ' of ' + ChunkText;

 Params.Chunk = 0;
 var NavButton1 = SPDbutton('SampleData', '&lt;&lt;', Params, (CurrentChunk > 0));
 Params.Chunk = Math.max(0, CurrentChunk-1);
 var NavButton2 = SPDbutton('SampleData', '&lt;', Params, (CurrentChunk > 0));
 Params.Chunk = Math.min(LastChunk, CurrentChunk+1);
 var NavButton3 = SPDbutton('SampleData', '&gt;', Params, (CurrentChunk < LastChunk));
 Params.Chunk = LastChunk;
 var NavButton4 = SPDbutton('SampleData', '&gt;&gt;', Params, (CurrentChunk < LastChunk));
 delete Params.Chunk;

 MessagesNav = BTNwrapper(NavButton1 + NavButton2 + '<span class="SPDnavText">' + ChunkText + '</span>' + NavButton3 + NavButton4);
 $("div.SPDnavPane").html(MessagesNav);
 
 TableHtml = '<table id="sample_data_table" class="SPDdataTable">';
 
 var CountOfSample = Response.Previews.length;
 var CountOfImported = Response.Imported;
 for (var SampleIndex = 0; SampleIndex < CountOfSample; SampleIndex++){
  var SdParams = Params;
  SdParams.TotalSd = CountOfSample;
  TableHtml += SPDpreviewRow(Response.Previews[SampleIndex], CountOfImported && (SampleIndex >= CountOfSample - CountOfImported), SdParams);
 }
 TableHtml += '</table>';

 $("div.SPDdataTable").html(TableHtml);

 if(0 >= CountOfSample){
  $("div#SPDimportOverwriteContainer").hide();
 }
 
 var Status = "";  
 if (CountOfImported){
  Status = '<span class="SPDsuccessMessage">' + Response.Imported + ' message';
  if (Response.Imported != 1) H += 's';
  Status += ' imported.</span>';
 }

 $("span.status").html(Status);

 $('tr.SPDimportedRow').each(function(){
  var Row = $(this);
  Row.removeClass('SPDimportedRow');
  Row.css('background-color', '#C6FF83'); // light green
  setTimeout(function(){
   Row.animate({'background-color':'#FDFDFD'}, 2000); // fade to original bg color
  }, 4000);
 });
 
 // Set change callback for the file input.
 var Form = $('form.SPDuploadForm');
 Form.find("input[type='file']").live('change', function(EventObj){
  var ImportButton = Form.find("a[id='SPDimportButton']");
  ImportButton.attr("href", "javascript:AFUuploadFile('/import_sample_data', $('form.SPDuploadForm'), SPDonImportBegin, SPDupdateSampleDataView, Params);");
  ImportButton.css( {"opacity": "1", "cursor": "pointer"} ); 
 });
 
 var NavPane = $('div.SPDnavPane');
 
 function SPDdisableNavPane(){
  NavPane.fadeTo('fast', 0.5);
  NavPane.append('<div class="SPDnavPaneBlocker"><img src="/js/mapper/images/spinner_wide.gif" /></div>');
  NavPane.find('div.SPDnavPaneBlocker img').fadeIn('slow');
 }
 
 NavPane.find('a').click(function(EventObj){ if (this.href != '') SPDdisableNavPane(); });
 
 if (Response.CountOfMessage) NavPane.find('span.SPDnavText').click(function(EventObj){
  var Div = $('div.SPDgoto');
  if (Div.size()){
   Div.remove();
  }else{
   Div = $('<div class="SPDgoto">Go to <input type="text" class="SPDgotoInput" /><img src="/js/mapper/images/ok.png" /></div>');
   $('body').append(Div);
   var NavPaneOffset = NavPane.offset();
   Div.css('left', NavPaneOffset.left + (NavPane.outerWidth() - Div.outerWidth())/2);
   Div.css('top',  NavPaneOffset.top + NavPane.outerHeight());
   
   var Input = Div.find('input');
   Input.val(Response.ChunkBegin+1);
   Input.focus();
   Input.select();
   
   function SPDonGoto(EventObj){
    var NewSd = parseInt(Input.val());
    if (isNaN(NewSd) || NewSd < 1){
     NewSd = 1;
    }else if (NewSd > Response.CountOfMessage){
     NewSd = Response.CountOfMessage;
    }
    NewSd--;
    if (Response.Index != NewSd){
     window.location = PAGhref('SampleData', {'ChannelGuid':ChannelInfo.Guid, 'ChannelName': ChannelInfo.Name, 'Index':NewSd});
     SPDdisableNavPane();
    }
    Div.remove();
   }
   
   Input.keydown(function(EventObj){
    if      (EventObj.keyCode == '13') SPDonGoto(EventObj);
    else if (EventObj.keyCode == '27') Div.remove();
   });
   
   Div.find('img').click(SPDonGoto);
  }
 });
 
 // We use a timeout to give the body a chance to render.
 if (CountOfImported) setTimeout(function(){
  window.scrollBy(0, $('body').outerHeight());
 }, 0);
}

function SPDonImportBegin(Form){
 $('#status').html('<img src="/js/mapper/images/spinner.gif" />');
 $('#import_file').attr('disabled', 'disabled');
 
 var ImportButton = Form.find("a[id='SPDimportButton']");
 ImportButton.attr("href", "javascript:void(0);"); 
 ImportButton.css( {"opacity": ".5", "cursor": "default"} ); 
}

/* Not allowed currently.  See #16266.
function SPDdeleteSampleData(Button, SampleDataId, ChannelGuid){
 if (!confirm('Delete this sample message?')) return;
 
 var DeletedRow = $(Button).closest('tr');
 var OriginalButtonSrc = Button.src;
 Ajax.post('/delete_sample_data', { "ChannelGuid" : ChannelGuid, "Id" : SampleDataId },
  function(Response, TextStatus, RequestObject){
   if (Response.ErrorMessage){
    $('#status').html('<span class="SPDerrorMessage">' + Resonse.ErrorMessage + '</span>');
    Button.src = OriginalButtonSrc;
    DeletedRow.css('background-color', '#FDFDFD'); // original bg color
    return;
   }
   $('#status').html('<span class="SPDsuccessMessage">1 message deleted.</span>');
   var OpCol = DeletedRow.find('td.SPDop');
   OpCol.css('height', OpCol.outerHeight());
   OpCol.html('');
 });
 Button.src = '/js/mapper/images/spinner_dark.gif';
 DeletedRow.css('background-color', '#DDDDDD');
 DeletedRow.css('text-decoration', 'line-through');

 --CountOfSample;

 if(0 >= CountOfSample){
  $("div#SPDimportOverwriteContainer").hide();
 }  
}*/
