<?cs include:"doctype.cs" ?>

<html>
<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Dashboard &gt; Removed Channel <?cs var:html_escape(Channel) ?></title>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery132/jquery-1.3.2.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.core.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.draggable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.resizable.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("ui.dialog.js") ?>"></script>  
   <link rel="stylesheet" type="text/css" href="jquery-ui/css/south-street/jquery-ui-1.7.2.custom.css" />  
   <?cs include:"styles.cs" ?>
</head>
<script type="text/javascript"> <!--

--></script>
<body class="tableft">

<?cs set:Navigation.CurrentTab = "Dashboard" ?>
<?cs include:"header.cs" ?>

<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/dashboard.html">Dashboard</a> &gt; Removed Channel <?cs var:html_escape(Channel) ?>
         </td>
      </tr>

      <tr>
         <td align="center" id="dashboard_body">
            <center>
            <?cs if:StatusMessage ?>
              <h3><font color="green"><?cs var:html_escape(StatusMessage) ?></font></h3>
            <?cs /if ?>
	    <table>
            <tr><td><a class="button" href="/"><span>Return to Dashboard</span></a></td></tr>
	    </table>
            </center>
         </td>
      </tr>
   </table>
</div>
               	<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
            <p>
		This page is displayed when a channel is removed.
	   </p>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana4_removing_channel.html" target="_blank">Removing a Channel</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>
</div>

</body>
</html>
