<?cs include:"doctype.cs" ?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; License Entitlement</title>
   <?cs include:"styles.cs" ?>
   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/utils/window.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("normalize.js") ?>"></script>
   <script type="text/javascript" src="<?cs var:iguana_version_js("tooltip.js") ?>"></script>
</head>

<body class="tabright">

<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>


<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; License Entitlement
         </td>
      </tr>

      <tr>
         <td id="dashboard_body">
               
               <center>
	       <?cs if:SettingsUpdated ?>
	       <p>
                  <h3><font color="green">Settings updated successfully.</font></h3>
	       </p>
	       <?cs /if ?>
               <table class="configuration">
                  <tr>
                     <th colspan="2">Current License Information</th>
                  </tr>
                  <tr>
                     <td class="left_column">Iguana ID</td>
                     <td> <?cs var:IguanaId ?></td>
                  </tr>
                  <tr>
                     <td class="left_column">Maximum Number of Concurrently Running Channels</td>
                     <td>
                        <?cs if:MaxCountOfConnection == 0 ?>
                           Unlimited
                        <?cs else ?>
                           <?cs var:MaxCountOfConnection ?>
                        <?cs /if ?>
                     </td>
                  </tr>
                  <tr>
                     <td class="left_column">License Expiry Date</td>
                     <td>
                        <?cs if:CountOfMonthToLicenseExpiry == 0 ?>
                           No Expiry
                        <?cs else ?>
	                        <?cs var:LicenseExpiryDate ?>
                        <?cs /if ?>
                     </td>
                  </tr>
                  <tr>
                     <td class="left_column">Maintenance Expiry Date</td>
                     <td>
                        <?cs if:CountOfMonthToMaintenanceExpiry == 0 ?>
                           No Expiry
                        <?cs else ?>
                           <?cs var:MaintenanceExpiryDate ?>
                        <?cs /if ?>
                     </td>
                  </tr>
               </table>
               
            
               <br>
               	 <table id="buttons"><tr><td>
                   <?cs if:CurrentUserCanAdmin ?>
                     <a id="ApplyChanges" class="button" href="/edit_license_settings.html" onclick="this.blur();"><span><img src="../<?cs var:skin("images/icon_edit.gif") ?>" /> &nbsp;Edit</span></a> 
                   <?cs else ?>
                     <div class="button_disable" id="DisabledEditButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span><img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>"/> &nbsp;Edit</span></div>
                   <?cs /if ?>
               	 </td></tr></table>
	   
            
            </center>
		   </td>
	   </tr>
   </table>

</div>
      <div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
            Page Help
         </th>
      </tr>
      <tr>
            <tr>
         <td id="side_body">
            <h4 class="side_title">Overview</h4>
	     <p>
	 This page shows the current license entitlement of this server.
	 </p>
            <?cs if:CurrentUserCanAdmin ?>
	    <p>Click <b>Enter License Code</b> to update your license information.</p>
            <?cs /if ?>
         </td>
      </tr>
      <tr>
         <td id="side_body">
            <h4 class="side_title">Help Links</h4>
            <ul class="help_link_icon">
            	<li>
            	<a href="http://www.interfaceware.com/manual/iguana4_config_license.html" target="_blank">License Entitlement</a>
            	</li>
            </ul>
         </td>
      </tr>
   </table>
   </div>
</body>

</html>
