<?cs include:"doctype.cs" ?>

<?cs # vim: set syntax=html :?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Remote Iguana Settings</title>
   <?cs include:"styles.cs" ?>
</head>

<body class="tabright">
<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>

<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; Remote Iguana Settings
         </td>
      </tr>

      <tr>
         <td id="dashboard_body" style="text-align: center;"><center>

         <table class="configuration" style="width: 20%" border="1">
            <tr class="header">
            <th>Remote Iguanas</th>
            </tr>
            <?cs each:Remote = RemoteIguana ?>	       
	       <td><?cs var:html_escape(Remote.OrigId) ?></td>
	       </tr>
	    <?cs /each ?> 
         </table>   
      <p>

      <table id="buttons"><tr><td>
      <!-- edit link -->
      <?cs if:CanAdmin ?>
         <a class="button" href="remote_iguana_settings.html" onclick="this.blur();"><span><img src="../<?cs var:skin("images/icon_edit.gif") ?>" /> &nbsp;Edit</span></a>
      <?cs else ?>
         <div class="button_disable" id="DisabledEditButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span><img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>"/> &nbsp;Edit</span></div>
     <?cs /if ?>
      </td>
      </tr></table>
        </center>
         </td>
      </tr>
   </table>
</div>

<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
	    Page Help
	 </th>
      </tr>
      <tr>
         <td id="side_body">
	    <h4 class="side_title">Overview</h4>
	    <p>
	       This page is used to list Iguana instances that can be accessed remotely through the dashboard. The same instances are also used when synchronizing user/permissions.
	    </p>
	    <p>
	       Instances should be of the form 'http://server:port'.
	    </p>
	 </td>
      </tr>
   </table>
</div>

</body>

</html>

